/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package foo;

import java.io.ByteArrayOutputStream;
import java.io.StringReader;
import javax.xml.namespace.QName;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPMessage;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import javax.xml.ws.Dispatch;
import javax.xml.ws.WebServiceRef;

/**
 *
 * @author bhakti
 */
public class Client {

    private static String request = new String("<S:Envelope xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">\n"
            + "  <S:Header>\n"
            + "    <wsa:To xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">http://localhost:8080//wsat-wsat/CoordinatorPortType</wsa:To>\n"
            + "    <wsa:Action xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">http://schemas.xmlsoap.org/ws/2004/10/wsat/Committed</wsa:Action>\n"
            + "    <wsat-wsat:txId xmlns:wsat-wsat=\"http://com.sun.xml.ws.tx.at/ws/2008/10/wsat\" xmlns=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">4A5453-02000000C9D77CCF646863702D6D6F756E746C617572656C2D656173742D31302D3134332D3135362D3137322E6C6F63616C2C7365727665722C50313030-646863702D6D6F756E746C617572656C2D656173742D31302D3134332D3135362D3137322E6C6F63616C2C7365727665722C503130302C00</wsat-wsat:txId>\n"
            + "    <wsat-wsat:branchQual xmlns:wsat-wsat=\"http://com.sun.xml.ws.tx.at/ws/2008/10/wsat\" xmlns=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">dhcp-mountlaurel-east-10-143-156-172.local&#044;server&#044;P100&#044;</wsat-wsat:branchQual>\n"
            + "    <wsat-wsat:routing xmlns:wsat-wsat=\"http://com.sun.xml.ws.tx.at/ws/2008/10/wsat\" xmlns=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">none</wsat-wsat:routing>\n"
            + "  </S:Header>\n"
            + "  <S:Body>\n"
            + "    <Committed xmlns=\"http://schemas.xmlsoap.org/ws/2004/10/wsat\" />\n"
            + "  </S:Body>\n"
            + "</S:Envelope>");
    Dispatch<SOAPMessage> dispatchMsg;
    final String NAMESPACEURI = "http://schemas.xmlsoap.org/ws/2004/10/wsat";
    private static final String SERVICE_NAME = "WSATCoordinator";
    private QName SERVICE_QNAME = new QName(NAMESPACEURI, SERVICE_NAME);
    private String PORT_NAME = "com.sun.xml.ws.tx.webservice.member.at.CompletionCoordinator";
    private QName PORT_QNAME = new QName(NAMESPACEURI, PORT_NAME);

    public static void main(String[] args) {
        Client client = new Client();
        //  client.doInvoke();
    }

    public void doInvoke(com.sun.xml.ws.tx.webservice.member.at.WSATCoordinator service) {
        System.out.println("doInvoke");
        try {
            dispatchMsg = service.createDispatch(PORT_QNAME, SOAPMessage.class, javax.xml.ws.Service.Mode.MESSAGE);
            SOAPMessage reqMsg = makeSOAPMessage(request);
            System.out.println("SOAPMessage request: " + getSOAPMessageAsString(reqMsg));
            SOAPMessage resMsg = dispatchMsg.invoke(reqMsg);
            System.out.println("SOAPPMessage response: " + getSOAPMessageAsString(resMsg));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static void commitOperation(com.sun.xml.ws.tx.webservice.member.at.Notification parameters) {
        com.sun.xml.ws.tx.webservice.member.at.WSATCoordinator service = new com.sun.xml.ws.tx.webservice.member.at.WSATCoordinator();
        com.sun.xml.ws.tx.webservice.member.at.CompletionCoordinatorPortType port = service.getCompletionCoordinator();
        port.commitOperation(parameters);


    }

    private String getSOAPMessageAsString(SOAPMessage msg) {
        ByteArrayOutputStream baos = null;
        String s = null;
        try {
            baos = new ByteArrayOutputStream();
            msg.writeTo(baos);
            s = baos.toString();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return s;
    }

    private SOAPMessage makeSOAPMessage(String msg) {
        try {
            MessageFactory factory = MessageFactory.newInstance();
            SOAPMessage message = factory.createMessage();
            message.getSOAPPart().setContent((Source) new StreamSource(new StringReader(msg)));
            message.saveChanges();
            return message;
        } catch (Exception e) {
            return null;
        }
    }

    private static void preparedOperation(com.sun.xml.ws.tx.webservice.member.at.Notification parameters) {
        com.sun.xml.ws.tx.webservice.member.at.WSATCoordinator service = new com.sun.xml.ws.tx.webservice.member.at.WSATCoordinator();
        com.sun.xml.ws.tx.webservice.member.at.CoordinatorPortType port = service.getCoordinator();
        port.preparedOperation(parameters);
    }
}
